diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/Makefile.def gcc-3.4.4-3/Makefile.def
--- gcc-3.4.4-3-orig/Makefile.def	2004-01-14 20:09:38.000000000 +0000
+++ gcc-3.4.4-3/Makefile.def	2006-05-13 17:35:14.000000000 +0100
@@ -116,6 +116,7 @@
 target_modules = { module= boehm-gc; };
 target_modules = { module= qthreads; };
 target_modules = { module= rda; };
+target_modules = { module= libphobos; };
 
 // These are (some of) the make targets to be done in each subdirectory.
 // Not all; these are the ones which don't have special options.
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/configure.in gcc-3.4.4-3/configure.in
--- gcc-3.4.4-3-orig/configure.in	2005-03-08 17:31:40.000000000 +0000
+++ gcc-3.4.4-3/configure.in	2005-06-03 23:16:54.000000000 +0100
@@ -157,6 +157,7 @@
 		target-newlib \
 		target-libstdc++-v3 \
 		target-libf2c \
+		target-libphobos \
 		${libgcj} \
 		target-libobjc"
 
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ada/a-tifiio.adb gcc-3.4.4-3/gcc/ada/a-tifiio.adb
--- gcc-3.4.4-3-orig/gcc/ada/a-tifiio.adb	2003-10-21 14:41:54.000000000 +0100
+++ gcc-3.4.4-3/gcc/ada/a-tifiio.adb	2005-06-03 21:03:34.000000000 +0100
@@ -550,7 +550,6 @@
          E       : Integer)
       is
          N  : constant Natural := (A + Max_Digits - 1) / Max_Digits + 1;
-         pragma Debug (Put_Line ("N =" & N'Img));
          Q  : array (1 .. N) of Int64 := (others => 0);
 
          XX : Int64 := X;
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ada/adaint.c gcc-3.4.4-3/gcc/ada/adaint.c
--- gcc-3.4.4-3-orig/gcc/ada/adaint.c	2004-01-13 11:51:32.000000000 +0000
+++ gcc-3.4.4-3/gcc/ada/adaint.c	2006-05-13 17:35:16.000000000 +0100
@@ -76,7 +76,6 @@
 #ifdef __MINGW32__
 #include "mingw32.h"
 #include <sys/utime.h>
-#include <ctype.h>
 #else
 #ifndef VMS
 #include <utime.h>
@@ -189,9 +188,32 @@
 #define DIR_SEPARATOR '/'
 #endif
 
-char __gnat_dir_separator = DIR_SEPARATOR;
+/* Override the system.h DIR_SEPARATOR define on windows. */
+#ifdef _WIN32
+const char __gnat_dir_separator = '\\';
+#else
+const char __gnat_dir_separator = DIR_SEPARATOR;
+#endif
 
-char __gnat_path_separator = PATH_SEPARATOR;
+/* This is all in libiberty filenames.h, but we can't include when IN_RTS, */ 
+#if defined(__MSDOS__) || defined(_WIN32) || defined(__EMX__) \
+    || defined (__CYGWIN__)
+#ifndef HAVE_DOS_BASED_FILE_SYSTEM
+#define HAVE_DOS_BASED_FILE_SYSTEM 1
+#endif
+#endif
+
+static __inline__ int
+__gnat_is_dir_separator (const char c)
+{
+#ifdef HAVE_DOS_BASED_FILE_SYSTEM
+  return (c == '/' ||  c == '\\');
+#else
+  return (c == '/' || c == DIR_SEPARATOR);
+#endif
+}
+
+const char __gnat_path_separator = PATH_SEPARATOR;
 
 /* The GNAT_LIBRARY_TEMPLATE contains a list of expressions that define
    the base filenames that libraries specified with -lsomelib options
@@ -366,7 +388,7 @@
   char full_path[256];
   int fd;
 
-  sprintf (full_path, "%s%c%s", dir, DIR_SEPARATOR, file);
+  sprintf (full_path, "%s%c%s", dir, __gnat_dir_separator, file);
   fd = open (full_path, O_CREAT | O_EXCL, 0600);
   if (fd < 0)
     return 0;
@@ -386,7 +408,7 @@
   char full_path[256];
   int fd;
 
-  sprintf (full_path, "%s%c%s", dir, DIR_SEPARATOR, file);
+  sprintf (full_path, "%s%c%s", dir, __gnat_dir_separator, file);
   fd = open (full_path, O_CREAT | O_EXCL, 0600);
   if (fd < 0)
     return 0;
@@ -408,7 +430,7 @@
   struct stat stat_result;
   int fd;
 
-  sprintf (full_path, "%s%c%s", dir, DIR_SEPARATOR, file);
+  sprintf (full_path, "%s%c%s", dir, __gnat_dir_separator, file);
   sprintf (temp_file, "%s-%ld-%ld", dir, (long) getpid(), (long) getppid ());
 
   /* Create the temporary file and write the process number.  */
@@ -482,9 +504,9 @@
 
    *length = strlen (dir);
 
-   if (dir [*length - 1] != DIR_SEPARATOR)
+   if (!__gnat_is_dir_separator (dir[*length - 1]))
      {
-       dir [*length] = DIR_SEPARATOR;
+       dir [*length] = __gnat_dir_separator;
        ++(*length);
      }
    dir[*length] = '\0';
@@ -1374,9 +1396,9 @@
 int
 __gnat_is_absolute_path (char *name)
 {
-  return (*name == '/' || *name == DIR_SEPARATOR
-#if defined (__EMX__) || defined (MSDOS) || defined (WINNT)
-      || (strlen (name) > 1 && isalpha (name[0]) && name[1] == ':')
+  return (__gnat_is_dir_separator (*name)
+#ifdef HAVE_DOS_BASED_FILE_SYSTEM
+	  || (name[0] && name[1] == ':')
 #endif
 	  );
 }
@@ -1853,7 +1875,7 @@
 
   /* If file_name include directory separator(s), try it first as
      a path name relative to the current directory */
-  for (ptr = file_name; *ptr && *ptr != '/' && *ptr != DIR_SEPARATOR; ptr++)
+  for (ptr = file_name; !__gnat_is_dir_separator (*ptr); ptr++)
     ;
 
   if (*ptr != 0)
@@ -1881,8 +1903,8 @@
         *ptr++ = *path_val++;
 
       ptr--;
-      if (*ptr != '/' && *ptr != DIR_SEPARATOR)
-        *++ptr = DIR_SEPARATOR;
+      if (!__gnat_is_dir_separator (*ptr))
+        *++ptr = __gnat_dir_separator;
 
       strcpy (++ptr, file_name);
 
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ada/ctrl_c.c gcc-3.4.4-3/gcc/ada/ctrl_c.c
--- gcc-3.4.4-3-orig/gcc/ada/ctrl_c.c	2003-10-31 01:08:40.000000000 +0000
+++ gcc-3.4.4-3/gcc/ada/ctrl_c.c	2005-06-03 21:03:36.000000000 +0100
@@ -120,6 +120,7 @@
     case CTRL_SHUTDOWN_EVENT:
       break;
     }
+  return TRUE;
 }
 
 void
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ada/expect.c gcc-3.4.4-3/gcc/ada/expect.c
--- gcc-3.4.4-3-orig/gcc/ada/expect.c	2003-10-31 01:08:42.000000000 +0000
+++ gcc-3.4.4-3/gcc/ada/expect.c	2005-06-03 21:03:36.000000000 +0100
@@ -80,7 +80,7 @@
 void
 __gnat_expect_portable_execvp (int *pid, char *cmd, char *argv[])
 {
-  *pid = (int) spawnve (_P_NOWAIT, cmd, argv, NULL);
+  *pid = (int) spawnve (_P_NOWAIT, cmd, (const char* const*)argv, NULL);
 }
 
 int
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ada/mingw32.h gcc-3.4.4-3/gcc/ada/mingw32.h
--- gcc-3.4.4-3-orig/gcc/ada/mingw32.h	2003-10-22 08:59:32.000000000 +0100
+++ gcc-3.4.4-3/gcc/ada/mingw32.h	2005-06-03 21:03:36.000000000 +0100
@@ -49,6 +49,10 @@
 
 #define OLD_MINGW (!(STD_MINGW))
 
+#if (STD_MINGW)
+#define MAXPATHLEN PATH_MAX /* This matches define in sys/param.h.  */
+#else
 #define MAXPATHLEN MAX_PATH
+#endif
 
 #endif /* _MINGW32_H */
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ada/mkdir.c gcc-3.4.4-3/gcc/ada/mkdir.c
--- gcc-3.4.4-3-orig/gcc/ada/mkdir.c	2003-10-31 01:08:44.000000000 +0000
+++ gcc-3.4.4-3/gcc/ada/mkdir.c	2006-05-13 17:35:16.000000000 +0100
@@ -51,7 +51,7 @@
 __gnat_mkdir (char *dir_name)
 {
 #if defined (_WIN32) || defined (__vxworks)
-  return mkdir (dir_name);
+  return (mkdir) (dir_name);
 #else
   return mkdir (dir_name, S_IRWXU | S_IRWXG | S_IRWXO);
 #endif
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ada/s-stoele.ads gcc-3.4.4-3/gcc/ada/s-stoele.ads
--- gcc-3.4.4-3-orig/gcc/ada/s-stoele.ads	2003-10-21 14:42:14.000000000 +0100
+++ gcc-3.4.4-3/gcc/ada/s-stoele.ads	2005-06-03 21:03:36.000000000 +0100
@@ -82,7 +82,7 @@
    function "-" (Left : Address; Right : Storage_Offset) return Address;
    pragma Convention (Intrinsic, "-");
    pragma Inline_Always ("-");
-   pragma Pure_Function ("+");
+   pragma Pure_Function ("-");
 
    function "-" (Left, Right : Address) return Storage_Offset;
    pragma Convention (Intrinsic, "-");
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/c-format.c gcc-3.4.4-3/gcc/c-format.c
--- gcc-3.4.4-3-orig/gcc/c-format.c	2005-05-01 11:38:56.000000000 +0100
+++ gcc-3.4.4-3/gcc/c-format.c	2005-06-03 21:03:34.000000000 +0100
@@ -30,6 +30,7 @@
 #include "intl.h"
 #include "diagnostic.h"
 #include "langhooks.h"
+
 
 /* Set format warning options according to a -Wformat=n option.  */
 
@@ -514,6 +515,9 @@
   { "Z", FMT_LEN_z, STD_EXT, NULL, 0, 0 },
   { "t", FMT_LEN_t, STD_C99, NULL, 0, 0 },
   { "j", FMT_LEN_j, STD_C99, NULL, 0, 0 },
+#ifdef TARGET_EXTRA_PRINTF_LENGTH_SPECIFIERS
+  TARGET_EXTRA_PRINTF_LENGTH_SPECIFIERS,
+#endif /* TARGET_EXTRA_PRINTF_LENGTH_SPECIFIERS */
   { NULL, 0, 0, NULL, 0, 0 }
 };
 
@@ -547,6 +551,9 @@
   { "z", FMT_LEN_z, STD_C99, NULL, 0, 0 },
   { "t", FMT_LEN_t, STD_C99, NULL, 0, 0 },
   { "j", FMT_LEN_j, STD_C99, NULL, 0, 0 },
+#ifdef TARGET_EXTRA_PRINTF_LENGTH_SPECIFIERS
+  TARGET_EXTRA_PRINTF_LENGTH_SPECIFIERS,
+#endif /* TARGET_EXTRA_PRINTF_LENGTH_SPECIFIERS */
   { NULL, 0, 0, NULL, 0, 0 }
 };
 
@@ -917,11 +924,11 @@
   { NULL, 0, 0, NOLENGTHS, NULL, NULL }
 };
 
-
 /* This must be in the same order as enum format_type.  */
 static const format_kind_info format_types_orig[] =
 {
-  { "printf",   printf_length_specs,  print_char_table, " +#0-'I", NULL, 
+  { "printf",   printf_length_specs,  print_char_table,
+    " +#0-'" TARGET_EXTRA_PRINTF_FLAG_CHARS, NULL, 
     printf_flag_specs, printf_flag_pairs,
     FMT_FLAG_ARG_CONVERT|FMT_FLAG_DOLLAR_MULTIPLE|FMT_FLAG_USE_DOLLAR|FMT_FLAG_EMPTY_PREC_OK,
     'w', 0, 'p', 0, 'L',
@@ -951,7 +958,8 @@
     0, 0, 'p', 0, 'L',
     NULL, &integer_type_node
   },
-  { "scanf",    scanf_length_specs,   scan_char_table,  "*'I", NULL, 
+   { "scanf",    scanf_length_specs,   scan_char_table,
+    "*'" TARGET_EXTRA_PRINTF_FLAG_CHARS, NULL, 
     scanf_flag_specs, scanf_flag_pairs,
     FMT_FLAG_ARG_CONVERT|FMT_FLAG_SCANF_A_KLUDGE|FMT_FLAG_USE_DOLLAR|FMT_FLAG_ZERO_WIDTH_BAD|FMT_FLAG_DOLLAR_GAP_POINTER_OK,
     'w', 0, 0, '*', 'L',
@@ -1929,7 +1937,13 @@
 	{
 	  while (fli->name != 0 && fli->name[0] != *format_chars)
 	    fli++;
-	  if (fli->name != 0)
+	  if (fli->name != 0
+#ifdef __MINGW32__
+	      /* Only accept "I64", not 'I' by itself.  */	
+	      && (format_chars[0] != 'I'
+		  || (format_chars[1] == '6' &&  format_chars[2] == '4'))
+#endif
+	     ) 
 	    {
 	      format_chars++;
 	      if (fli->double_name != 0 && fli->name[0] == *format_chars)
@@ -1941,6 +1955,10 @@
 		}
 	      else
 		{
+#ifdef __MINGW32__
+	          if (fli->name[0] == 'I')
+		    format_chars += 2;
+#endif
 		  length_chars = fli->name;
 		  length_chars_val = fli->index;
 		  length_chars_std = fli->std;
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/c-incpath.c gcc-3.4.4-3/gcc/c-incpath.c
--- gcc-3.4.4-3-orig/gcc/c-incpath.c	2004-05-31 11:37:48.000000000 +0100
+++ gcc-3.4.4-3/gcc/c-incpath.c	2006-05-13 17:35:16.000000000 +0100
@@ -306,13 +306,18 @@
   struct cpp_dir *p;
 
 #if defined (HAVE_DOS_BASED_FILE_SYSTEM)
-  /* Convert all backslashes to slashes.  The native CRT stat()
-     function does not recognise a directory that ends in a backslash
-     (unless it is a drive root dir, such "c:\").  Forward slashes,
-     trailing or otherwise, cause no problems for stat().  */
+  /* Remove unnecessary trailing slashes.  On some versions of MS
+     Windows, trailing  _forward_ slashes cause no problems for stat().
+     On newer versions, stat() does not recognise a directory that ends
+     in a '\\' or '/', unless it is a drive root dir, such "c:\").  */
   char* c;
   for (c = path; *c; c++)
     if (*c == '\\') *c = '/';
+  /* Strip trailing slashes, but preserve the lead '/' or a slash
+     that follows a ':' such as lead "c:/" or "//./c:/" */
+  c--;
+  for (; c > path && c[0] == '/' && c[-1] != ':'; c--)
+    *c = '\0';
 #endif
 
   p = xmalloc (sizeof (struct cpp_dir));
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/c-opts.c gcc-3.4.4-3/gcc/c-opts.c
--- gcc-3.4.4-3-orig/gcc/c-opts.c	2005-03-09 01:00:56.000000000 +0000
+++ gcc-3.4.4-3/gcc/c-opts.c	2005-06-03 21:03:34.000000000 +0100
@@ -29,6 +29,7 @@
 #include "flags.h"
 #include "toplev.h"
 #include "langhooks.h"
+#include "hosthooks.h"
 #include "tree-inline.h"
 #include "diagnostic.h"
 #include "intl.h"
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/c-pch.c gcc-3.4.4-3/gcc/c-pch.c
--- gcc-3.4.4-3-orig/gcc/c-pch.c	2004-03-24 22:27:54.000000000 +0000
+++ gcc-3.4.4-3/gcc/c-pch.c	2005-06-03 21:03:34.000000000 +0100
@@ -181,7 +181,6 @@
     fatal_error ("can't write %s: %m", pch_file);
   
   buf = xmalloc (16384);
-  fflush (asm_out_file);
 
   if (fseek (asm_out_file, asm_file_startpos, SEEK_SET) != 0)
     fatal_error ("can't seek in %s: %m", asm_file_name);
@@ -198,8 +197,9 @@
       written += size;
     }
   free (buf);
-  /* asm_out_file can be written afterwards, so must be flushed first.  */
-  fflush (asm_out_file);
+  /* asm_out_file can be written afterwards, so must
+     clear _IOREAD flags first.  */
+  fseek (asm_out_file, 0, SEEK_END);
 
   gt_pch_save (pch_outfile);
   cpp_write_pch_state (parse_in, pch_outfile);
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/calls.c gcc-3.4.4-3/gcc/calls.c
--- gcc-3.4.4-3-orig/gcc/calls.c	2005-04-06 22:01:44.000000000 +0100
+++ gcc-3.4.4-3/gcc/calls.c	2006-06-10 12:29:42.000000000 +0100
@@ -4215,7 +4215,16 @@
       /* Handle calls that pass values in multiple non-contiguous
 	 locations.  The PA64 has examples of this for library calls.  */
       if (reg != 0 && GET_CODE (reg) == PARALLEL)
+#ifndef GPC
 	emit_group_load (reg, val, NULL_TREE, GET_MODE_SIZE (GET_MODE (val)));
+#else
+        {
+          int valsize = GET_MODE_SIZE (GET_MODE (val));
+          if (valsize == 0 && GET_MODE (val) == VOIDmode)
+              valsize = GET_MODE_SIZE (GET_MODE (reg));
+          emit_group_load (reg, val, NULL_TREE, valsize);
+        }
+#endif /* GPC */
       else if (reg != 0 && partial == 0)
 	emit_move_insn (reg, val);
 
